unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Series5: TLineSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Series6: TLineSeries;
    Image1: TImage;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    function fy(a, b, x: double): boolean;
    procedure Linedraw;
    procedure Textdraw;
    procedure area;
    procedure second_imperfect_elliptic_integral(z, K: double; var F, E: Double);
    procedure arch;
    procedure archoutdraw;
    procedure integral;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses  math;

var
  a, b : double;
  x, y : double;
  xp   : integer;
  stb, ltb, mtb: string;

procedure TForm1.Button1Click(Sender: TObject);
var
  ch : integer;
begin
//  a := 3;
//  b := 3;
//  x := 4;
  val(LabeledEdit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    exit;
  end;
  if a <= 0 then begin
    application.MessageBox('̒l̓[傫ĉB','',0);
    exit;
  end;
  val(LabeledEdit2.Text, b, ch);
  if ch <> 0 then begin
    application.MessageBox('̒lɊԈႢ܂B','',0);
    exit;
  end;
  if b <= 0 then begin
    application.MessageBox('b̒l̓[傫ĉB','',0);
    exit;
  end;
  val(LabeledEdit3.Text, x, ch);
  if ch <> 0 then begin
    application.MessageBox('w̒lɊԈႢ܂B','',0);
    exit;
  end;
  if not fy(a, b, x) then
    application.MessageBox('w̒ĺA̒l傫ȂĂ͂܂B','',0);
end;

// |`,`̖ʐρA̕ϕmFvZ
procedure TForm1.integral;
var
  i, n     : integer;
  dx, s, y0, y1, ax, L, ss: double;
  st, su   : string;
  ch0, ch1 : char;
  En       : integer;
begin
  s := 0;
  dx  := (x - a) / 1000;                      // x'
  n := round((x - a) / dx);                   // 
  dx := (x - a) / n;                          // x
  L := 0;
  ax :=  a;                                   // ԓ_ŌvZ
  y0 := b / a * sqrt(ax * ax - a * a);        // y̒lvZ
  for i := 1 to n do begin
    ax := dx * i + a;
    y1 := b / a * sqrt(ax * ax - a * a);      // y̒lvZ
    s := s + (y0 + y1) * dx;                  // ʐ (y0+y0)͗TCh
    L := L + sqrt((y1 - y0) * (y1 - y0) + dx * dx);
    y0 := y1;
  end;
  ss := y0 * x - s;                           // ʐ

  memo1.Lines.Add('');

  st := floatTostr(s);                        // |`ʐς̕ϊ
  su := '';
  n := length(st);                            // 
  En := n;
  for i := 1 to n do begin                    // w
    if stb[i] = 'E' then En := i;
  end;
  for i := 1 to n do begin                    // ̌v錅o
    ch0 := stb[i];
    ch1 := st[i];
    if ch0 = ch1 then su := su + ch0
                 else break;
  end;
  if su <> '' then
    for i := En to n do begin                 // wZ
      ch0 := stb[i];
      su := su + ch0;
    end;
  if su = '' then su := floattostr(s);
  memo1.Lines.Add('ϕmFSu = ' + su);

  st := floatTostr(ss);                       // ʐϕϊ
  su := '';
  n := length(st);                            // 
  En := n;
  for i := 1 to n do begin                    // w
    if mtb[i] = 'E' then En := i;
  end;
  for i := 1 to n do begin                    // ̌v錅o
    ch0 := mtb[i];
    ch1 := st[i];
    if ch0 = ch1 then su := su + ch0
                 else break;
  end;
  if su <> '' then
    for i := En to n do begin                 // wZ
      ch0 := mtb[i];
      su := su + ch0
    end;
  if su = '' then su := floattostr(ss);
  memo1.Lines.Add('ϕmFSo = ' + su);

  st := floatTostr(L);                        // oȌʂ̒ϊ
  su := '';
  n := length(st);                            // 
  En := n;
  for i := 1 to n do begin                    // w
    if ltb[i] = 'E' then En := i;
  end;
  for i := 1 to n do begin                    // ̌v錅o
    ch0 := ltb[i];
    ch1 := st[i];
    if ch0 = ch1 then su := su + ch0
                 else break;
  end;
  if su <> '' then
    for i := En to n do begin                 // wZ
      ch0 := ltb[i];
      su := su + ch0
    end;
  if su = '' then su := floattostr(L);
  memo1.Lines.Add('ϕmF L = ' + su);
end;

//-------------------------------
// PQȉ~ϕ
// FBnKn[0] Pȉ~ϕ
// EBnKn[0] Qȉ~ϕ
// fϊ
// Q px deg
// K S
//-------------------------------
procedure TForm1.second_imperfect_elliptic_integral(z, K: double; var F, E: Double);
var
  I, MI   : integer;
  Kn      : array of double;         // Kn
  knd     : array of double;         // k'n
  N2SKn   : array of double;         // 2/(1+Kn)
  T2SKnd  : array of double;         // P2/(1+Kn')
  BRad    : array of double;         // (rad)
  SinBn   : array of double;         // sinn
  FBnKn   : array of double;         // F(n,kn)
  EBnKn   : array of double;         // E(n,kn)
  LnD     : double;
  Q       : double;
begin
  // K = 0 ͉̎~Ȃ̂pi̊pxlrad܂B
  Q := arcsin(z);
  if K = 0 then begin
    E := Q;
    F := E;
    exit;
  end;
  // ̎͂P܂@ZG[h~ׁ̈Al͐܂B
  if (K = 1) and (Q >= pi / 2) then begin
    E := 1;
    F := 1;
    exit;
  end;

  // (1 > K > 0 and Q <= 90) or (K = 1 and Q < 90)̎
  MI := 0;
  LND := 0;
  setlength(kn,  MI + 1);         // kn
  kn[0] := K;
  while LND <> Kn[MI] do begin
    LnD := Kn[MI];
    inc(MI);
    setlength(kn,  MI + 1);         // kn
    kn[MI] := 2 * sqrt(Kn[MI - 1])/(1 + Kn[MI - 1]);
  end;
  Dec(MI);
  setlength(kn,      MI + 1);         // kn
  setlength(knd,     MI + 1);         // k'n
  setlength(N2SKn,   MI + 1);         // 2/(1+Kn)
  setlength(T2SKnd,  MI + 1);         // P2/(1+Kn')
  setlength(BRad,    MI + 1);         // (rad)
  setlength(SinBn,   MI + 1);         // sinn
  setlength(FBnKn,   MI + 1);         // F(n,kn)
  setlength(EBnKn,   MI + 1);         // E(n,kn)

  knd[0] := 1;
  for I := 1 to MI do
    knd[I] := (1 - kn[I - 1]) / (1 + Kn[I - 1]);
  for I := 0 to MI do
    N2SKn[I] := 2 / (1 + kn[I]);
  T2SKnd[MI] := N2SKn[MI];
  for I := MI - 1 downto 0 do
    T2SKnd[I] := T2SKnd[I + 1] * N2SKn[I];
  BRad[0] := Q;
  for I := 1 to MI do
    BRad[I] := (arcsin(kn[I - 1] * sin(Brad[I - 1])) + Brad[I - 1]) / 2;
  for I := 0 to MI do
    SinBn[I] := sin(Brad[I]);
  LnD := LN((1 + sin(Brad[MI])) / cos(Brad[MI]));
  for I := 0 to MI do
    FBnKn[I] := T2SKnd[I] * LnD;
  F := FBnKn[0];
  EBnKn[MI] := sin(Brad[MI]);
  for I := MI - 1 downto 0 do
    EBnKn[I] :=  (2 * EBnKn[I + 1] + 2 * knd[I + 1] * FBnKn[I + 1]) / (1 + knd[I + 1]) - kn[I] * SinBn[I];
  E := EBnKn[0];
end;

// `̓hԂ
procedure TForm1.archoutdraw;
var
  i, kn           : integer;
  Xbase, Ybase : integer;
  Xn, Yn, yni  : integer;
  Yx           : double;
  ax,    ay    : double;
  dx, px       : double;
  py           : double;
begin
  Image1.Canvas.Pen.Color := clSkyblue;     // FF
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Style := psSolid;
  Xbase := Series2.CalcXPos(1);             // _ʒuW X
  Ybase := Series2.CalcYPos(1);             // _ʒuW y
  Xn    := Series1.CalcXPos(xp);            // XʒuxW
  Yn    := Series1.CalcYPos(xp);            // YʒuyW
  Image1.Canvas.MoveTo(Xbase, Ybase);       // E̕`
  Image1.Canvas.LineTo(Xn, Yn);
  Yn    := Series3.CalcYPos(xp);
  Image1.Canvas.MoveTo(Xbase, Ybase);
  Image1.Canvas.LineTo(Xn, Yn);
  ax := (Xn - Xbase) / x;                   // xɑ΂XW̕ω
  y := b / a * sqrt(x * x - a * a);         // oȐy̒l
  ay := (Yn - Ybase) / y;                   // yɑ΂YW̕ω
  kn := round((Xn - Xbase) / 5);            // 0`X̕
  dx := x / kn;                             // x
  for i := 0 to kn do begin                 // hԂ̕`
    px := i * dx;
    py := y / x * px;
    Xn := round(ax * px) + Xbase;
    if px < a then begin                    // a̒l܂ł͏̋E牺̋E܂
      Yn := round(ay * py) + Ybase;
      Image1.Canvas.MoveTo(Xn, Yn);
      Yn := - round(ay * py) + Ybase;
      Image1.Canvas.LineTo(Xn, Yn);
    end
    else begin                              // a̒l𒴂oȔ͈͂ĕ`
      Yn := round(ay * py) + Ybase;
      Yx := b / a * sqrt(px * px - a * a);
      yni := Ybase + round(ay * Yx);
      Image1.Canvas.MoveTo(Xn, Yn);
      Image1.Canvas.LineTo(Xn, Yni);
      Yn := - round(ay * py) + Ybase;
      yni := Ybase - round(ay * Yx);
      Image1.Canvas.MoveTo(Xn, Yn);
      Image1.Canvas.LineTo(Xn, Yni);
    end;
  end;
end;


// oȌʂ̒vZ
// L oȌʂ̒̓񕪂̈
procedure TForm1.arch;
var
  e, k, z   : double;
  Fzk, Ezk  : double;
  L         : double;
begin
  e := sqrt(a * a + b * b) / a;                             // Se
  memo1.Lines.Add('S e = ' + floatTostr(e));
  k := 1 / e;                                               // k
  z := sqrt((x * x - a * a) / (x * x - k * k * a * a));     // z
  second_imperfect_elliptic_integral(z, k, Fzk, Ezk);       // ȉ~ϕ
  L := (a * (1 - k * k) * Fzk - a * Ezk + x * z) / k;       // L
  ltb := floatTostr(L);
  memo1.Lines.Add('oȌʂ̒ @L = ' + ltb);
end;

// oȐ |`Ɛ`̖ʐς̖ʐ
procedure TForm1.area;
var
  y, s, so: double;
begin
  memo1.Clear;
  y := b / a * sqrt(x * x - a * a);                         // y
  s := x * y - a * b * arccosh(x / a);                      // s |`̖ʐ
  stb := floatTostr(s);
  memo1.Lines.Add('|`̖ʐ Su = ' + stb);
  so := a * b * arccosh(x / a);                             // so `̖ʐ
  mtb := floatTostr(so);
  memo1.Lines.Add('`̖ʐ So = ' + mtb);
end;

// TChartɕo
procedure TForm1.Textdraw;
var
  xpp, ypp: integer;
begin
  Image1.Canvas.Font.Size := 15;                         // ̍Size(integer)ł͂
  Image1.Canvas.Font.Color := clRed;
  Image1.Canvas.Font.Name := 'Tahoma';
  xpp := (Series2.CalcXPos(1) + Series1.CalcXPos(0)) div 2;   // axʒuvZ
  ypp := Series2.CalcyPos(1) - 4;                             // ayʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'a');                       // a̕`
  xpp := Series1.CalcXPos(0) - 14;                            // bxʒuvZ
  ypp := Series1.CalcYPos(0) - ((Series1.CalcYPos(0) - Series2.CalcYPos(2)) div 2) - 10; // byʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'b');                      // b̕`
  xpp := (Series2.CalcXPos(1) + Series2.CalcXPos(2)) div 2 - 12; // cxʒuvZ
  ypp := (Series2.CalcYPos(1) + Series2.CalcYPos(2)) div 2 - 25; // cyʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'c');                           // c̕`
  Image1.Canvas.Font.Color := clblack;
  xpp := Series5.CalcXPos(0) - 17;                            // xxʒuvZ
  ypp := Series2.CalcYPos(3) - 25;                            // xyʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'x');                       // x̕`
  xpp := Series1.CalcXPos(0) + 17;                            // LxʒuvZ
  ypp := Series1.CalcYPos(0) + ((Series3.CalcYPos(xp) - Series1.CalcYPos(0)) div 2) - 17;  // LyʒuvZ
  Image1.Canvas.TextOut(xpp, ypp, 'L');                       // L̕`
end;

// ̕`
procedure TForm1.Linedraw;
var
  i       : integer;
  xp1, yp1: integer;
  xp2, yp2: integer;
begin
  xp1 := Series1.CalcXPos(0);               // oȐ_X
  yp1 := Series1.CalcYPos(0);               // oȐ_y
  xp2 := Series2.CalcXPos(2);               // y=b/a * b  xW xp1Ɠ
  yp2 := Series2.CalcYPos(2);               // y=b/a * b  yW
  Image1.Canvas.Pen.Color := clBlue;
  Image1.Canvas.Pen.Width := 3;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.MoveTo(xp1,yp1);            // b ̐
  Image1.Canvas.LineTo(xp2,yp2);
  xp2 := Series2.CalcXPos(1);               // x=0 ̍W
  yp2 := Series2.CalcyPos(1);               // y=0 ̍W
  Image1.Canvas.LineTo(xp2,yp2);            // c ̐@Op`ΐ
  Image1.Canvas.Pen.Color := clGreen;
  Image1.Canvas.Pen.Width := 3;
  Image1.Canvas.Pen.Style := psSolid;
  for i := 0 to xp do begin                 // oȐ|`hԂ
    if i mod 2 = 0 then begin
    xp1 := Series1.CalcXPos(i);
    yp1 := Series1.CalcYPos(i);
    xp2 := Series3.CalcXPos(i);
    yp2 := Series3.CalcYPos(i) - 2;         // LRedLine܂
    Image1.Canvas.MoveTo(xp1,yp1);
    Image1.Canvas.LineTo(xp2,yp2);
    end;
  end;
  Image1.Canvas.Pen.Color := clblack;
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Style := psDashdotdot;
  xp1 := Series2.CalcXPos(0);
  xp2 := Series2.CalcXPos(4);
  yp1 := Series4.CalcYPos(1);
  yp2 := Series4.CalcYPos(1);
  Image1.Canvas.MoveTo(xp1,yp1);            // X
  Image1.Canvas.LineTo(xp2,yp2);
  xp1 := Series2.CalcXPos(1);
  xp2 := Series2.CalcXPos(1);
  yp1 := Series5.CalcYPos(0);
  yp2 := Series5.CalcYPos(1);
  Image1.Canvas.MoveTo(xp1,yp1);            // y
  Image1.Canvas.LineTo(xp2,yp2);
  xp1 := Series2.CalcXPos(1);
  xp2 := Series1.CalcXPos(0);
  yp1 := Series2.CalcYPos(1);
  yp2 := Series1.CalcYPos(0);
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Width := 3;
  Image1.Canvas.MoveTo(xp1,yp1);            // a̐
  Image1.Canvas.LineTo(xp2,yp2);
end;

// oȐ̕`
function TForm1.fy(a, b, x: double): boolean;
const
  nk100 = 100;                              // oȐ
var
  i  : integer;
  dx, ax: double;
  Xmax, Xmin, ymax : double;
begin
  if a >= x then begin                      // a < x ̊mF
    result := false;
    exit;
  end;
  result := true;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(rect(0, 0, Image1. Width, Image1. Height));
  Image1.Canvas.Brush.Style := bsClear;
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
  Series1.Clear;                            // oȐ+
  Series2.Clear;                            // y = a/b * x
  Series3.Clear;                            // oȐ-
  Series4.Clear;                            // y = -a/b * x
  Series5.Clear;                            // ẍʒu
  Series6.Clear;                            // L̐
  xp := 0;                                  // oȐSeries1X̒lɂȂz̈ʒu NA
  dx := (x * 1.5 - a) / nk100;              // oȐvZ̃x
  ymax := b / a * sqrt(x * x * 1.5 * 1.5 - a * a);    // yől ŏl-ymax
  Xmax := x * 1.5;                                    // xől
  Xmin := -x / 2;                                     // xŏl
// TChartXYvZ
// Maximum > Minimum ׁ̏A݂̒lƁAVZbglŏԐݒ
// XỸXP[𓯂ɐݒ肵܂
  if ymax > (Xmax - Xmin) / 2 then begin
    if Chart1.LeftAxis.Maximum < ymax then begin
      Chart1.LeftAxis.Maximum := ymax;
      Chart1.LeftAxis.Minimum := -ymax;
    end
    else begin
      Chart1.LeftAxis.Minimum := -ymax;
      Chart1.LeftAxis.Maximum := ymax;
    end;
    if Chart1.BottomAxis.Maximum < ymax * 2 + Xmin then begin
      Chart1.BottomAxis.Maximum := ymax * 2 + Xmin;
      Chart1.BottomAxis.Minimum := Xmin;
    end
    else begin
      Chart1.BottomAxis.Minimum := Xmin;
      Chart1.BottomAxis.Maximum := ymax * 2 + Xmin;
    end;
  end
  else begin
    ymax := (Xmax - Xmin) / 2;
    if Chart1.LeftAxis.Maximum < ymax then begin
      Chart1.LeftAxis.Maximum := ymax;
      Chart1.LeftAxis.Minimum := -ymax;
    end
    else begin
      Chart1.LeftAxis.Minimum := -ymax;
      Chart1.LeftAxis.Maximum := ymax;
    end;
    if Chart1.BottomAxis.Maximum < Xmax then begin
      Chart1.BottomAxis.Maximum := Xmax;
      Chart1.BottomAxis.Minimum := Xmin;
    end
    else begin
      Chart1.BottomAxis.Minimum := Xmin;
      Chart1.BottomAxis.Maximum := Xmax;
    end;
  end;
// oȐOt}
  for i := 0 to nk100 do begin
    ax := a + i * dx;                           // oȐx̒l
    if ax <= x then xp := i;                    // oȐSeries1X̒lɂȂz̈ʒu
    y := b / a * sqrt(ax * ax - a * a);         // oȐy̒l
    if ax <= x then Series6.AddXY(ax, -y);;     // L͈̔̓Ot
    Series1.AddXY(ax, y);                       // +oȐ
    Series3.AddXY(ax, -y);                      // -oȐ
  end;
// y = b/a * x, -y ̒Ot, Ẍʒu̒
  dx := -a / 5;
  y := b / a * dx;
  Series2.AddXY(dx, y);          // ŏ̈ʒu oȐ@ y = b/a * x @@  Series(0)
  Series4.AddXY(dx, -y);         //      -y
  dx := 0;
  y := 0;
  Series2.AddXY(dx, y);          // [̈ʒu    oȐ@ y = b/a * x    Series(1)
  Series4.AddXY(dx, -y);         //      -y
  dx := a;
  y := b / a * dx;
  Series2.AddXY(dx, y);          // äʒu       oȐ@ y = b/a * x    Series(2)
  Series4.AddXY(dx, -y);         //      -y
  dx := x;
  y := b / a * dx;
  Series2.AddXY(dx, y);          // ẍʒu   oȐ@ y = b/a * x        Series(3)
  Series4.AddXY(dx, -y);         //      -y
  dx := x * 1.5;
  y := b / a * dx;
  Series2.AddXY(dx, y);          // x*1.5̈ʒu   oȐ@ y = b/a * x    Series(4)
  Series4.AddXY(dx, -y);         //      -y
  y := ymax;
  Series5.AddXY(x, -y);          // Ẍʒu̐-y
  Series5.AddXY(x, y);           // Ẍʒu̐ y
  Chart1.Update;
  application.ProcessMessages;   // Chart1Ot`҂
  archoutdraw;
  Linedraw;                      // `
  application.ProcessMessages;
  Textdraw;                      // `
  area;                          // |`̖ʐς̖ʐ
  arch;                          // oȌʂ̒vZ
  application.ProcessMessages;
  integral;                      // ϕɂmF
  Chart1.BackImage.Bitmap := Image1.Picture.Bitmap;
  Memo1.Lines.Add('|`@ΐF');
  Memo1.Lines.Add('`@F');
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  bm : Tbitmap;
begin
  bm := Tbitmap.Create;
  bm.Width := Chart1.Width;
  bm.Height := Chart1.Height;
  Image1.Width := Chart1.Width;
  Image1.Height := Chart1.Height;
  Image1.Picture.Bitmap := bm;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Visible := False;
  Label3.Caption := 'oȐ' + #13#10 + '͈ X';
  bm.Free;
end;

end.
